Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -2417,202 +2673,213 @@
 !
 !--    Gaseous tracer concentrations in #/m3
-       IF ( salsa_gases_from_chem )  THEN       
-!       
+       IF ( salsa_gases_from_chem )  THEN
+!
 !--       Convert concentrations in ppm to #/m3
           zgso4  = chem_species(gas_index_chem(1))%conc(k,j,i) * ppm_to_nconc(k)
           zghno3 = chem_species(gas_index_chem(2))%conc(k,j,i) * ppm_to_nconc(k)
           zgnh3  = chem_species(gas_index_chem(3))%conc(k,j,i) * ppm_to_nconc(k)
-          zgocnv = chem_species(gas_index_chem(4))%conc(k,j,i) * ppm_to_nconc(k)     
-          zgocsv = chem_species(gas_index_chem(5))%conc(k,j,i) * ppm_to_nconc(k)                 
+          zgocnv = chem_species(gas_index_chem(4))%conc(k,j,i) * ppm_to_nconc(k)
+          zgocsv = chem_species(gas_index_chem(5))%conc(k,j,i) * ppm_to_nconc(k)
        ELSE
-          zgso4  = salsa_gas(1)%conc(k,j,i) 
-          zghno3 = salsa_gas(2)%conc(k,j,i) 
-          zgnh3  = salsa_gas(3)%conc(k,j,i) 
-          zgocnv = salsa_gas(4)%conc(k,j,i) 
+          zgso4  = salsa_gas(1)%conc(k,j,i)
+          zghno3 = salsa_gas(2)%conc(k,j,i)
+          zgnh3  = salsa_gas(3)%conc(k,j,i)
+          zgocnv = salsa_gas(4)%conc(k,j,i)
           zgocsv = salsa_gas(5)%conc(k,j,i)
-       ENDIF    
-!
-!--    ***************************************!
-!--                   Run SALSA               !
-!--    ***************************************!
-       CALL run_salsa( in_p(k), in_cw(k), in_cs(k), in_t(k), in_u(k),          &
-                       in_adn(k), in_lad, zgso4, zgocnv, zgocsv, zghno3, zgnh3,&
-                       aero, prtcl, kvis(k), Sc(k,:), vd(k,:), dt_salsa )
-!--    ***************************************!
+       ENDIF
+!
+!--    Calculate aerosol processes:
+!--    *********************************************************************************************
+!
+!--    Coagulation
+       IF ( lscoag )   THEN
+          CALL coagulation( aero, dt_salsa, in_t(k), in_p(k) )
+       ENDIF
+!
+!--    Condensation
+       IF ( lscnd )   THEN
+          CALL condensation( aero, zgso4, zgocnv, zgocsv,  zghno3, zgnh3, in_cw(k), in_cs(k),      &
+                             in_t(k), in_p(k), dt_salsa, prtcl )
+       ENDIF
+!
+!--    Deposition
+       IF ( lsdepo )  THEN
+          CALL deposition( aero, in_t(k), in_adn(k), in_u(k), in_lad, kvis(k), schmidt_num(k,:),   &
+                           vd(k,:) )
+       ENDIF
+!
+!--    Size distribution bin update
+       IF ( lsdistupdate )   THEN
+          CALL distr_update( aero )
+       ENDIF
+!--    *********************************************************************************************
+
        IF ( lsdepo ) sedim_vd(k,j,i,:) = vd(k,:)
-!                            
+!
 !--    Calculate changes in concentrations
-       DO bb = 1, nbins
-          aerosol_number(bb)%conc(k,j,i) = aerosol_number(bb)%conc(k,j,i)      &
-                                 +  ( aero(bb)%numc - aero_old(bb)%numc ) * flag
+       DO ib = 1, nbins_aerosol
+          aerosol_number(ib)%conc(k,j,i) = aerosol_number(ib)%conc(k,j,i) + ( aero(ib)%numc -      &
+                                           aero_old(ib)%numc ) * flag
        ENDDO
-       
-       IF ( iso4 > 0 )  THEN
+
+       IF ( index_so4 > 0 )  THEN
           vc = 1
-          str = ( iso4-1 ) * nbins + 1
-          endi = iso4 * nbins
-          cc = 1
+          str = ( index_so4-1 ) * nbins_aerosol + 1
+          endi = index_so4 * nbins_aerosol
+          ic = 1
           DO ss = str, endi
-             aerosol_mass(ss)%conc(k,j,i) = aerosol_mass(ss)%conc(k,j,i)       &
-                               + ( aero(cc)%volc(vc) - aero_old(cc)%volc(vc) ) &
-                               * arhoh2so4 * flag
-             cc = cc+1
+             aerosol_mass(ss)%conc(k,j,i) = aerosol_mass(ss)%conc(k,j,i) + ( aero(ic)%volc(vc) -   &
+                                            aero_old(ic)%volc(vc) ) * arhoh2so4 * flag
+             ic = ic+1
           ENDDO
        ENDIF
-       
-       IF ( ioc > 0 )  THEN
+
+       IF ( index_oc > 0 )  THEN
           vc = 2
-          str = ( ioc-1 ) * nbins + 1
-          endi = ioc * nbins
-          cc = 1
+          str = ( index_oc-1 ) * nbins_aerosol + 1
+          endi = index_oc * nbins_aerosol
+          ic = 1
           DO ss = str, endi
-             aerosol_mass(ss)%conc(k,j,i) = aerosol_mass(ss)%conc(k,j,i)       &
-                               + ( aero(cc)%volc(vc) - aero_old(cc)%volc(vc) ) &
-                               * arhooc * flag
-             cc = cc+1
+             aerosol_mass(ss)%conc(k,j,i) = aerosol_mass(ss)%conc(k,j,i) + ( aero(ic)%volc(vc) -   &
+                                            aero_old(ic)%volc(vc) ) * arhooc * flag
+             ic = ic+1
           ENDDO
        ENDIF
-       
-       IF ( ibc > 0 )  THEN
+
+       IF ( index_bc > 0 )  THEN
           vc = 3
-          str = ( ibc-1 ) * nbins + 1 + fn1a
-          endi = ibc * nbins
-          cc = 1 + fn1a
+          str = ( index_bc-1 ) * nbins_aerosol + 1 + end_subrange_1a
+          endi = index_bc * nbins_aerosol
+          ic = 1 + end_subrange_1a
           DO ss = str, endi
-             aerosol_mass(ss)%conc(k,j,i) = aerosol_mass(ss)%conc(k,j,i)       &
-                               + ( aero(cc)%volc(vc) - aero_old(cc)%volc(vc) ) &
-                               * arhobc * flag 
-             cc = cc+1
+             aerosol_mass(ss)%conc(k,j,i) = aerosol_mass(ss)%conc(k,j,i) + ( aero(ic)%volc(vc) -   &
+                                            aero_old(ic)%volc(vc) ) * arhobc * flag
+             ic = ic+1
           ENDDO
        ENDIF
-       
-       IF ( idu > 0 )  THEN
+
+       IF ( index_du > 0 )  THEN
           vc = 4
-          str = ( idu-1 ) * nbins + 1 + fn1a
-          endi = idu * nbins
-          cc = 1 + fn1a
+          str = ( index_du-1 ) * nbins_aerosol + 1 + end_subrange_1a
+          endi = index_du * nbins_aerosol
+          ic = 1 + end_subrange_1a
           DO ss = str, endi
-             aerosol_mass(ss)%conc(k,j,i) = aerosol_mass(ss)%conc(k,j,i)       &
-                               + ( aero(cc)%volc(vc) - aero_old(cc)%volc(vc) ) &
-                               * arhodu * flag
-             cc = cc+1
+             aerosol_mass(ss)%conc(k,j,i) = aerosol_mass(ss)%conc(k,j,i) + ( aero(ic)%volc(vc) -   &
+                                            aero_old(ic)%volc(vc) ) * arhodu * flag
+             ic = ic+1
           ENDDO
        ENDIF
-       
-       IF ( iss > 0 )  THEN
+
+       IF ( index_ss > 0 )  THEN
           vc = 5
-          str = ( iss-1 ) * nbins + 1 + fn1a
-          endi = iss * nbins
-          cc = 1 + fn1a
+          str = ( index_ss-1 ) * nbins_aerosol + 1 + end_subrange_1a
+          endi = index_ss * nbins_aerosol
+          ic = 1 + end_subrange_1a
           DO ss = str, endi
-             aerosol_mass(ss)%conc(k,j,i) = aerosol_mass(ss)%conc(k,j,i)       &
-                               + ( aero(cc)%volc(vc) - aero_old(cc)%volc(vc) ) &
-                               * arhoss * flag
-             cc = cc+1
+             aerosol_mass(ss)%conc(k,j,i) = aerosol_mass(ss)%conc(k,j,i) + ( aero(ic)%volc(vc) -   &
+                                            aero_old(ic)%volc(vc) ) * arhoss * flag
+             ic = ic+1
           ENDDO
        ENDIF
-       
-       IF ( ino > 0 )  THEN
+
+       IF ( index_no > 0 )  THEN
           vc = 6
-          str = ( ino-1 ) * nbins + 1
-          endi = ino * nbins
-          cc = 1
+          str = ( index_no-1 ) * nbins_aerosol + 1
+          endi = index_no * nbins_aerosol
+          ic = 1
           DO ss = str, endi
-             aerosol_mass(ss)%conc(k,j,i) = aerosol_mass(ss)%conc(k,j,i)       &
-                               + ( aero(cc)%volc(vc) - aero_old(cc)%volc(vc) ) &
-                               * arhohno3 * flag
-             cc = cc+1
+             aerosol_mass(ss)%conc(k,j,i) = aerosol_mass(ss)%conc(k,j,i) + ( aero(ic)%volc(vc) -   &
+                                            aero_old(ic)%volc(vc) ) * arhohno3 * flag
+             ic = ic+1
           ENDDO
        ENDIF
-       
-       IF ( inh > 0 )  THEN
+
+       IF ( index_nh > 0 )  THEN
           vc = 7
-          str = ( ino-1 ) * nbins + 1
-          endi = ino * nbins
-          cc = 1
+          str = ( index_nh-1 ) * nbins_aerosol + 1
+          endi = index_nh * nbins_aerosol
+          ic = 1
           DO ss = str, endi
-             aerosol_mass(ss)%conc(k,j,i) = aerosol_mass(ss)%conc(k,j,i)       &
-                               + ( aero(cc)%volc(vc) - aero_old(cc)%volc(vc) ) &
-                               * arhonh3 * flag
-             cc = cc+1
+             aerosol_mass(ss)%conc(k,j,i) = aerosol_mass(ss)%conc(k,j,i) + ( aero(ic)%volc(vc) -   &
+                                            aero_old(ic)%volc(vc) ) * arhonh3 * flag
+             ic = ic+1
           ENDDO
        ENDIF
-       
+
        IF ( advect_particle_water )  THEN
           nc_h2o = get_index( prtcl,'H2O' )
           vc = 8
-          str = ( nc_h2o-1 ) * nbins + 1
-          endi = nc_h2o * nbins
-          cc = 1
+          str = ( nc_h2o-1 ) * nbins_aerosol + 1
+          endi = nc_h2o * nbins_aerosol
+          ic = 1
           DO ss = str, endi
-             aerosol_mass(ss)%conc(k,j,i) = aerosol_mass(ss)%conc(k,j,i)       &
-                               + ( aero(cc)%volc(vc) - aero_old(cc)%volc(vc) ) &
-                               * arhoh2o * flag
+             aerosol_mass(ss)%conc(k,j,i) = aerosol_mass(ss)%conc(k,j,i) + ( aero(ic)%volc(vc) -   &
+                                            aero_old(ic)%volc(vc) ) * arhoh2o * flag
              IF ( prunmode == 1 )  THEN
-                aerosol_mass(ss)%init(k) = MAX( aerosol_mass(ss)%init(k),      &
-                                               aerosol_mass(ss)%conc(k,j,i) )
+                aerosol_mass(ss)%init(k) = MAX( aerosol_mass(ss)%init(k),                          &
+                                                aerosol_mass(ss)%conc(k,j,i) )
+                IF ( k == nzb+1 )  THEN
+                   aerosol_mass(ss)%init(k-1) = 0.0_wp
+                ELSEIF ( k == nzt  )  THEN
+                   aerosol_mass(ss)%init(k+1) = aerosol_mass(ss)%init(k)
+                ENDIF
              ENDIF
-             cc = cc+1                              
+             ic = ic+1
           ENDDO
        ENDIF
-
+!
 !--    Condensation of precursor gases
        IF ( lscndgas )  THEN
-          IF ( salsa_gases_from_chem )  THEN          
-!          
+          IF ( salsa_gases_from_chem )  THEN
+!
 !--          SO4 (or H2SO4)
-             chem_species( gas_index_chem(1) )%conc(k,j,i) =                &
-                            chem_species( gas_index_chem(1) )%conc(k,j,i) + &
-                                                  ( zgso4 / ppm_to_nconc(k) - &
-                       chem_species( gas_index_chem(1) )%conc(k,j,i) ) * flag
-!                            
+             ig = gas_index_chem(1)
+             chem_species(ig)%conc(k,j,i) = chem_species(ig)%conc(k,j,i) + ( zgso4 /               &
+                                            ppm_to_nconc(k) - chem_species(ig)%conc(k,j,i) ) * flag
+!
 !--          HNO3
-             chem_species( gas_index_chem(2) )%conc(k,j,i) =                &
-                            chem_species( gas_index_chem(2) )%conc(k,j,i) + &
-                                                 ( zghno3 / ppm_to_nconc(k) - &
-                       chem_species( gas_index_chem(2) )%conc(k,j,i) ) * flag
-!                           
+             ig = gas_index_chem(2)
+             chem_species(ig)%conc(k,j,i) = chem_species(ig)%conc(k,j,i) + ( zghno3 /              &
+                                            ppm_to_nconc(k) - chem_species(ig)%conc(k,j,i) ) * flag
+!
 !--          NH3
-             chem_species( gas_index_chem(3) )%conc(k,j,i) =                &
-                            chem_species( gas_index_chem(3) )%conc(k,j,i) + &
-                                                  ( zgnh3 / ppm_to_nconc(k) - &
-                       chem_species( gas_index_chem(3) )%conc(k,j,i) ) * flag
-!                            
+             ig = gas_index_chem(3)
+             chem_species(ig)%conc(k,j,i) = chem_species(ig)%conc(k,j,i) + ( zgnh3 /               &
+                                            ppm_to_nconc(k) - chem_species(ig)%conc(k,j,i) ) * flag
+!
 !--          non-volatile OC
-             chem_species( gas_index_chem(4) )%conc(k,j,i) =                &
-                            chem_species( gas_index_chem(4) )%conc(k,j,i) + &
-                                                 ( zgocnv / ppm_to_nconc(k) - &
-                       chem_species( gas_index_chem(4) )%conc(k,j,i) ) * flag
-!                           
+             ig = gas_index_chem(4)
+             chem_species(ig)%conc(k,j,i) = chem_species(ig)%conc(k,j,i) + ( zgocnv /              &
+                                            ppm_to_nconc(k) - chem_species(ig)%conc(k,j,i) ) * flag
+!
 !--          semi-volatile OC
-             chem_species( gas_index_chem(5) )%conc(k,j,i) =                &
-                            chem_species( gas_index_chem(5) )%conc(k,j,i) + &
-                                                 ( zgocsv / ppm_to_nconc(k) - &
-                       chem_species( gas_index_chem(5) )%conc(k,j,i) ) * flag                 
-          
+             ig = gas_index_chem(5)
+             chem_species(ig)%conc(k,j,i) = chem_species(ig)%conc(k,j,i) + ( zgocsv /              &
+                                            ppm_to_nconc(k) - chem_species(ig)%conc(k,j,i) ) * flag
+
           ELSE
-!          
+!
 !--          SO4 (or H2SO4)
-             salsa_gas(1)%conc(k,j,i) = salsa_gas(1)%conc(k,j,i) + ( zgso4 -   &
-                                          salsa_gas(1)%conc(k,j,i) ) * flag
-!                            
+             salsa_gas(1)%conc(k,j,i) = salsa_gas(1)%conc(k,j,i) + ( zgso4 -                       &
+                                        salsa_gas(1)%conc(k,j,i) ) * flag
+!
 !--          HNO3
-             salsa_gas(2)%conc(k,j,i) = salsa_gas(2)%conc(k,j,i) + ( zghno3 -  &
-                                          salsa_gas(2)%conc(k,j,i) ) * flag
-!                           
+             salsa_gas(2)%conc(k,j,i) = salsa_gas(2)%conc(k,j,i) + ( zghno3 -                      &
+                                        salsa_gas(2)%conc(k,j,i) ) * flag
+!
 !--          NH3
-             salsa_gas(3)%conc(k,j,i) = salsa_gas(3)%conc(k,j,i) + ( zgnh3 -   &
-                                          salsa_gas(3)%conc(k,j,i) ) * flag
-!                            
+             salsa_gas(3)%conc(k,j,i) = salsa_gas(3)%conc(k,j,i) + ( zgnh3 -                       &
+                                        salsa_gas(3)%conc(k,j,i) ) * flag
+!
 !--          non-volatile OC
-             salsa_gas(4)%conc(k,j,i) = salsa_gas(4)%conc(k,j,i) + ( zgocnv -  &
-                                          salsa_gas(4)%conc(k,j,i) ) * flag
-!                           
+             salsa_gas(4)%conc(k,j,i) = salsa_gas(4)%conc(k,j,i) + ( zgocnv -                      &
+                                        salsa_gas(4)%conc(k,j,i) ) * flag
+!
 !--          semi-volatile OC
-             salsa_gas(5)%conc(k,j,i) = salsa_gas(5)%conc(k,j,i) + ( zgocsv -  &
-                                          salsa_gas(5)%conc(k,j,i) ) * flag
+             salsa_gas(5)%conc(k,j,i) = salsa_gas(5)%conc(k,j,i) + ( zgocsv -                      &
+                                        salsa_gas(5)%conc(k,j,i) ) * flag
           ENDIF
        ENDIF
-!                
+!
 !--    Tendency of water vapour mixing ratio is obtained from the 
 !--    change in RH during SALSA run. This releases heat and changes pt.
@@ -2621,101 +2888,33 @@
 !
        IF ( feedback_to_palm )  THEN
-          q_p(k,j,i) = q_p(k,j,i) + 1.0_wp / ( in_cw(k) * in_adn(k) + 1.0_wp ) &
-                       ** 2.0_wp * ( in_cw(k) - cw_old ) * in_adn(k) 
-          pt_p(k,j,i) = pt_p(k,j,i) + alv / c_p * ( in_cw(k) - cw_old ) *      &
-                        in_adn(k) / ( in_cw(k) / in_adn(k) + 1.0_wp ) ** 2.0_wp&
-                        * pt_p(k,j,i) / in_t(k)
-       ENDIF
-                         
+          q_p(k,j,i) = q_p(k,j,i) + 1.0_wp / ( in_cw(k) * in_adn(k) + 1.0_wp )**2 *                &
+                       ( in_cw(k) - cw_old ) * in_adn(k) * flag
+          pt_p(k,j,i) = pt_p(k,j,i) + alv / c_p * ( in_cw(k) - cw_old ) * in_adn(k) / ( in_cw(k) / &
+                        in_adn(k) + 1.0_wp )**2 * pt_p(k,j,i) / in_t(k) * flag
+       ENDIF
+
     ENDDO   ! k
-!    
-!-- Set surfaces and wall fluxes due to deposition  
-    IF ( lsdepo_topo  .AND.  prunmode == 3 )  THEN 
+!
+!-- Set surfaces and wall fluxes due to deposition
+    IF ( lsdepo  .AND.  lsdepo_surf  .AND.  prunmode == 3 )  THEN 
        IF ( .NOT. land_surface  .AND.  .NOT. urban_surface )  THEN
-          CALL depo_topo( i, j, surf_def_h(0), vd, Sc, kvis, in_u, rho_air_zw )
+          CALL depo_surf( i, j, surf_def_h(0), vd, schmidt_num, kvis, in_u, .TRUE. )
           DO  l = 0, 3
-             CALL depo_topo( i, j, surf_def_v(l), vd, Sc, kvis, in_u,          &
-                             rho_air_zw**0.0_wp )
+             CALL depo_surf( i, j, surf_def_v(l), vd, schmidt_num, kvis, in_u, .FALSE., l )
           ENDDO
        ELSE
-          CALL depo_topo( i, j, surf_usm_h, vd, Sc, kvis, in_u, rho_air_zw )
+          CALL depo_surf( i, j, surf_usm_h, vd, schmidt_num, kvis, in_u, .TRUE. )
           DO  l = 0, 3
-             CALL depo_topo( i, j, surf_usm_v(l), vd, Sc, kvis, in_u,          &
-                             rho_air_zw**0.0_wp )
+             CALL depo_surf( i, j, surf_usm_v(l), vd, schmidt_num, kvis, in_u, .FALSE., l )
           ENDDO
-          CALL depo_topo( i, j, surf_lsm_h, vd, Sc, kvis, in_u, rho_air_zw )
+          CALL depo_surf( i, j, surf_lsm_h, vd, schmidt_num, kvis, in_u, .TRUE. )
           DO  l = 0, 3
-             CALL depo_topo( i, j, surf_lsm_v(l), vd, Sc, kvis, in_u,          &
-                             rho_air_zw**0.0_wp )
+             CALL depo_surf( i, j, surf_lsm_v(l), vd, schmidt_num, kvis, in_u, .FALSE., l )
           ENDDO
        ENDIF
     ENDIF
-    
+
  END SUBROUTINE salsa_driver
 
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> The SALSA subroutine
-!> Modified for the new aerosol datatype,
-!> Juha Tonttila, FMI, 2014.
-!> Only aerosol processes included, Mona Kurppa, UHel, 2017
-!------------------------------------------------------------------------------!    
- SUBROUTINE run_salsa( ppres, pcw, pcs, ptemp, mag_u, adn, lad, pc_h2so4,      &
-                       pc_ocnv, pc_ocsv, pc_hno3, pc_nh3, paero, prtcl, kvis,  &
-                       Sc, vc, ptstep )
-
-    IMPLICIT NONE
-!
-!-- Input parameters and variables 
-    REAL(wp), INTENT(in) ::  adn    !< air density (kg/m3)
-    REAL(wp), INTENT(in) ::  lad    !< leaf area density (m2/m3)
-    REAL(wp), INTENT(in) ::  mag_u  !< magnitude of wind (m/s)
-    REAL(wp), INTENT(in) ::  ppres  !< atmospheric pressure at each grid 
-                                    !< point (Pa)
-    REAL(wp), INTENT(in) ::  ptemp  !< temperature at each grid point (K)
-    REAL(wp), INTENT(in) ::  ptstep !< time step of salsa processes (s)
-    TYPE(component_index), INTENT(in) :: prtcl  !< part. component index table
-!       
-!-- Input variables that are changed within:
-    REAL(wp), INTENT(inout) ::  kvis     !< kinematic viscosity of air (m2/s)
-    REAL(wp), INTENT(inout) ::  Sc(:)    !< particle Schmidt number
-    REAL(wp), INTENT(inout) ::  vc(:)    !< particle fall speed (m/s, 
-                                         !< sedimentation velocity)
-!-- Gas phase concentrations at each grid point (#/m3)
-    REAL(wp), INTENT(inout) ::  pc_h2so4 !< sulphuric acid
-    REAL(wp), INTENT(inout) ::  pc_hno3  !< nitric acid
-    REAL(wp), INTENT(inout) ::  pc_nh3   !< ammonia
-    REAL(wp), INTENT(inout) ::  pc_ocnv  !< nonvolatile OC
-    REAL(wp), INTENT(inout) ::  pc_ocsv  !< semivolatile OC
-    REAL(wp), INTENT(inout) ::  pcs      !< Saturation concentration of water
-                                         !< vapour (kg/m3)
-    REAL(wp), INTENT(inout) ::  pcw      !< Water vapour concentration (kg/m3)                                                   
-    TYPE(t_section), INTENT(inout) ::  paero(fn2b) 
-!
-!-- Coagulation
-    IF ( lscoag )   THEN
-       CALL coagulation( paero, ptstep, ptemp, ppres )
-    ENDIF
-!
-!-- Condensation
-    IF ( lscnd )   THEN
-       CALL condensation( paero, pc_h2so4, pc_ocnv, pc_ocsv,  pc_hno3, pc_nh3, &
-                          pcw, pcs, ptemp, ppres, ptstep, prtcl )
-    ENDIF   
-!    
-!-- Deposition
-    IF ( lsdepo )  THEN
-       CALL deposition( paero, ptemp, adn, mag_u, lad, kvis, Sc, vc ) 
-    ENDIF        
-!
-!-- Size distribution bin update
-!-- Mona: why done 3 times in SALSA-standalone?
-    IF ( lsdistupdate )   THEN
-       CALL distr_update( paero )
-    ENDIF
-    
-  END SUBROUTINE run_salsa 
- 
 !------------------------------------------------------------------------------!
 ! Description:
@@ -2727,9 +2926,9 @@
 !------------------------------------------------------------------------------!
  SUBROUTINE set_salsa_runtime( prunmode )
- 
+
     IMPLICIT NONE
-    
+
     INTEGER(iwp), INTENT(in) ::  prunmode
-    
+
     SELECT CASE(prunmode)
 
@@ -2740,7 +2939,8 @@
           lscndh2oae   = .FALSE.
           lsdepo       = .FALSE.
-          lsdepo_vege  = .FALSE.
-          lsdepo_topo  = .FALSE.
+          lsdepo_pcm   = .FALSE.
+          lsdepo_surf  = .FALSE.
           lsdistupdate = .TRUE.
+          lspartition  = .FALSE.
 
        CASE(2)  !< Spinup period
@@ -2756,12 +2956,11 @@
           lscndh2oae   = nlcndh2oae
           lsdepo       = nldepo
-          lsdepo_vege  = nldepo_vege
-          lsdepo_topo  = nldepo_topo
+          lsdepo_pcm   = nldepo_pcm
+          lsdepo_surf  = nldepo_surf
           lsdistupdate = nldistupdate
-
     END SELECT
 
 
- END SUBROUTINE set_salsa_runtime 
+ END SUBROUTINE set_salsa_runtime
  
 !------------------------------------------------------------------------------!
@@ -2770,5 +2969,5 @@
 !> Calculates the absolute temperature (using hydrostatic pressure), saturation 
 !> vapour pressure and mixing ratio over water, relative humidity and air 
-!> density needed in the SALSA model. 
+!> density needed in the SALSA model.
 !> NOTE, no saturation adjustment takes place -> the resulting water vapour 
 !> mixing ratio can be supersaturated, allowing the microphysical calculations
@@ -2779,34 +2978,36 @@
 !------------------------------------------------------------------------------!
  SUBROUTINE salsa_thrm_ij( i, j, p_ij, temp_ij, cw_ij, cs_ij, adn_ij )
- 
-    USE arrays_3d,                                                             &
-        ONLY: p, pt, q, zu
-       
-    USE basic_constants_and_equations_mod,                                     &
+
+    USE arrays_3d,                                                                                 &
+        ONLY: pt, q, zu
+
+    USE basic_constants_and_equations_mod,                                                         &
         ONLY:  barometric_formula, exner_function, ideal_gas_law_rho, magnus
-       
-    USE control_parameters,                                                    &
+
+    USE control_parameters,                                                                        &
         ONLY: pt_surface, surface_pressure
-       
+
     IMPLICIT NONE
-   
-    INTEGER(iwp), INTENT(in) ::  i
-    INTEGER(iwp), INTENT(in) ::  j
-    REAL(wp), DIMENSION(:), INTENT(inout) ::  adn_ij
-    REAL(wp), DIMENSION(:), INTENT(inout) ::  p_ij       
-    REAL(wp), DIMENSION(:), INTENT(inout) ::  temp_ij
-    REAL(wp), DIMENSION(:), INTENT(inout), OPTIONAL ::  cw_ij
-    REAL(wp), DIMENSION(:), INTENT(inout), OPTIONAL ::  cs_ij
-    REAL(wp), DIMENSION(nzb:nzt+1) ::  e_s !< saturation vapour pressure
-                                           !< over water (Pa)
-    REAL(wp) ::  t_surface !< absolute surface temperature (K)
-!
-!-- Pressure p_ijk (Pa) = hydrostatic pressure + perturbation pressure (p)
+
+    INTEGER(iwp), INTENT(in) ::  i  !<
+    INTEGER(iwp), INTENT(in) ::  j  !<
+
+    REAL(wp) ::  t_surface  !< absolute surface temperature (K)
+
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  e_s  !< saturation vapour pressure over water (Pa)
+
+    REAL(wp), DIMENSION(:), INTENT(inout) ::  adn_ij   !< air density (kg/m3)
+    REAL(wp), DIMENSION(:), INTENT(inout) ::  p_ij     !< air pressure (Pa)
+    REAL(wp), DIMENSION(:), INTENT(inout) ::  temp_ij  !< air temperature (K)
+
+    REAL(wp), DIMENSION(:), INTENT(inout), OPTIONAL ::  cw_ij  !< water vapour concentration (kg/m3)
+    REAL(wp), DIMENSION(:), INTENT(inout), OPTIONAL ::  cs_ij  !< saturation water vap. conc.(kg/m3)
+!
+!-- Pressure p_ijk (Pa) = hydrostatic pressure
     t_surface = pt_surface * exner_function( surface_pressure * 100.0_wp )
-    p_ij(:) = barometric_formula( zu, t_surface, surface_pressure * 100.0_wp ) &
-              + p(:,j,i)
-!             
+    p_ij(:) = barometric_formula( zu, t_surface, surface_pressure * 100.0_wp )
+!
 !-- Absolute ambient temperature (K)
-    temp_ij(:) = pt(:,j,i) * exner_function( p_ij(:) )       
+    temp_ij(:) = pt(:,j,i) * exner_function( p_ij(:) )
 !
 !-- Air density
@@ -2815,5 +3016,5 @@
 !-- Water vapour concentration r_v (kg/m3)
     IF ( PRESENT( cw_ij ) )  THEN
-       cw_ij(:) = ( q(:,j,i) / ( 1.0_wp - q(:,j,i) ) ) * adn_ij(:) 
+       cw_ij(:) = ( q(:,j,i) / ( 1.0_wp - q(:,j,i) ) ) * adn_ij(:)
     ENDIF
 !
@@ -2822,8 +3023,8 @@
        e_s(:) = 611.0_wp * EXP( alv_d_rv * ( 3.6609E-3_wp - 1.0_wp /           &
                 temp_ij(:) ) )! magnus( temp_ij(:) )
-       cs_ij(:) = ( 0.622_wp * e_s / ( p_ij(:) - e_s(:) ) ) * adn_ij(:) 
+       cs_ij(:) = ( 0.622_wp * e_s / ( p_ij(:) - e_s(:) ) ) * adn_ij(:)
     ENDIF
 
- END SUBROUTINE salsa_thrm_ij 
+ END SUBROUTINE salsa_thrm_ij
 
 !------------------------------------------------------------------------------!
